import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Author Nicolas Kammerdiener 
 * Chapter 4
 * Actor: Lobster
 */
public class Lobster  extends Animal
{
    /**
     * Act - do whatever the Lobster wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkKeypress();  
        lookForCrab();
    }

    /**
     * Check whether we have stumbled upon a worm
     * If we have, eat it. If not, do nothing. 
     */
    public void lookForCrab()
    {
        if (canSee(Crab.class))
        {
            eat(Crab.class);
            Greenfoot.playSound("au.wav");
            Greenfoot.stop();
        }
    }

    /**
     * This takes a random number from 0 to 100.
     * If it is less than ten it turns a random number. Else it just goes straight. 
     */
    public void randomTurn()
    {
        if (Greenfoot.getRandomNumber(100)<10)
        {
            turn(Greenfoot.getRandomNumber(90)-45);
        }
    }

    /**
     * This checks to see if it is at the edge of the world.
     * If it is then it turns 17 degrees. If not it runs the randomTurn() method.
     */
    public void turnAtEdge()
    {
        if (atWorldEdge())
        {
            turn(17);
        }
    }

    /**
     * This checks to see whether a key is pressed.
     * If it is it turns according to which key is pressed 
     */
    public void checkKeypress()
    {
        if (Greenfoot.isKeyDown("w"))
        {
            move();
        }

        if (Greenfoot.isKeyDown("a"))
        {
            turn(-4);
        }

        if (Greenfoot.isKeyDown("d"))
        {
            turn(4);
        }

    }
}